/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.trademark@0.2.0

// imports
import {IPostalAddress} from './org.accordproject.address@0.2.0';
import {ICountry,IPlace} from './org.accordproject.geo@0.2.0';
import {IPerson,IGender} from './org.accordproject.person@0.2.0';
import {IEntityType} from './org.accordproject.usa.entity@0.2.0';
import {IColor} from './org.accordproject.color@0.2.0';
import {IConcept} from './concerto@1.0.0';

// interfaces
export interface ITrademarkAssetIdentifier extends IConcept {
   assetSerialNumber: string;
   assetRegistrationNumber?: string;
   assetCountry: ICountry;
}

export interface IGoodsAndServices extends IConcept {
   gsDescription: string;
   intlClass: string;
   usClass?: string;
   currentFilingBasis: string;
   origFilingBasis?: string;
}

export interface IOwner extends IPerson {
}

export interface IRegistrant extends IPerson {
}

export interface IAssignee extends IPerson {
}

export interface ICorrespondent extends IPerson {
}

export interface IAttorney extends IPerson {
}

export enum MarkStatus {
   Live = 'Live',
   Dead = 'Dead',
}

export enum MarkType {
   Standard_Character = 'Standard_Character',
   Special_Form = 'Special_Form',
   Sound = 'Sound',
}

export enum Register {
   Principal = 'Principal',
   Supplemental = 'Supplemental',
}

export interface ITrademarkAsset extends IConcept {
   assetIdentifier: ITrademarkAssetIdentifier;
   encodedMarkImage: string;
   markDescription: string;
   goodsandServices?: IGoodsAndServices[];
   originalOwner?: IOwner;
   entityType?: EntityType;
   originalRegistrant?: IRegistrant;
   currentAssignee?: IAssignee;
   currentCorrespondent?: ICorrespondent;
   attorneyRepresentative?: IAttorney;
   markStatus?: MarkStatus;
   markType?: MarkType;
   register?: Register;
   literalElement?: string;
   colorClaim?: boolean;
   colorFeature?: Color[];
   filingDate?: Date;
   registrationDate?: Date;
}

